# $Id: cyrillize.tcl,v 1.2 2002/09/10 14:56:36 alexey Exp $

namespace eval cyrillize {
}

proc cyrillize::load_table {} {
    variable engrus

    set f [file join [file dirname [info script]] engrus.tbl]
    set fd [open $f]
    fconfigure $fd -encoding koi8-r
    set engrus_table [read $fd]
    close $fd

    foreach {f t} $engrus_table {
	set engrus($f) $t
    }
}

cyrillize::load_table

#puts [array get cyrillize::engrus]

proc cyrillize::do {s} {
    variable engrus

    set res ""
    foreach c [split $s ""] {
	if {[info exists engrus($c)]} {
	    append res $engrus($c)
	} elseif {[info exists engrus([string tolower $c])]} {
	    append res [string toupper $engrus([string tolower $c])]
	} else {
	    append res $c
	}
    }
    return $res
}

#puts [cyrillize::do Ghbdtn]

proc cyrillize::word {iw} {
    set ins [lindex [split [$iw index insert] .] 1]
    set line [$iw get "insert linestart" "insert lineend"]
    set wordstart [string wordstart $line [expr $ins - 1]]
    set wordend [clength [string trimright \
			      [crange $line 0 [expr $wordstart - 1]]]]
    set word [crange $line $wordstart [expr $ins - 1]]

    set newword [do $word]
    $iw delete "insert linestart +$wordstart chars" insert
    $iw insert insert $newword

    $iw mark set insert "insert linestart +$wordend chars"
}

proc cyrillize::setup_bindings {chatid type} {
    variable history

    set iw [chat::input_win $chatid]
    bind $iw <Control-quoteright> \
	[list [namespace current]::word $iw]
    bind $iw <Control-quoteright> +break
}

hook::add open_chat_post_hook [namespace current]::cyrillize::setup_bindings



